=begin
#EVE Swagger Interface

#An OpenAPI for EVE Online

OpenAPI spec version: 0.8.6

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.3.1

=end

require "uri"

module ESI
  class FleetsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end

    # Kick fleet member
    # Kick a fleet member  --- 
    # @param fleet_id ID for a fleet
    # @param member_id The character ID of a member in this fleet
    # @param [Hash] opts the optional parameters
    # @option opts [String] :datasource The server name you would like data from (default to tranquility)
    # @option opts [String] :token Access token to use if unable to set a header
    # @return [nil]
    def delete_fleets_fleet_id_members_member_id(fleet_id, member_id, opts = {})
      delete_fleets_fleet_id_members_member_id_with_http_info(fleet_id, member_id, opts)
      return nil
    end

    # Kick fleet member
    # Kick a fleet member  --- 
    # @param fleet_id ID for a fleet
    # @param member_id The character ID of a member in this fleet
    # @param [Hash] opts the optional parameters
    # @option opts [String] :datasource The server name you would like data from
    # @option opts [String] :token Access token to use if unable to set a header
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_fleets_fleet_id_members_member_id_with_http_info(fleet_id, member_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: FleetsApi.delete_fleets_fleet_id_members_member_id ..."
      end
      # verify the required parameter 'fleet_id' is set
      if @api_client.config.client_side_validation && fleet_id.nil?
        fail ArgumentError, "Missing the required parameter 'fleet_id' when calling FleetsApi.delete_fleets_fleet_id_members_member_id"
      end
      # verify the required parameter 'member_id' is set
      if @api_client.config.client_side_validation && member_id.nil?
        fail ArgumentError, "Missing the required parameter 'member_id' when calling FleetsApi.delete_fleets_fleet_id_members_member_id"
      end
      if @api_client.config.client_side_validation && opts[:'datasource'] && !['tranquility', 'singularity'].include?(opts[:'datasource'])
        fail ArgumentError, 'invalid value for "datasource", must be one of tranquility, singularity'
      end
      # resource path
      local_var_path = "/v1/fleets/{fleet_id}/members/{member_id}/".sub('{' + 'fleet_id' + '}', fleet_id.to_s).sub('{' + 'member_id' + '}', member_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'datasource'] = opts[:'datasource'] if !opts[:'datasource'].nil?
      query_params[:'token'] = opts[:'token'] if !opts[:'token'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['evesso']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FleetsApi#delete_fleets_fleet_id_members_member_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete fleet squad
    # Delete a fleet squad, only empty squads can be deleted  --- 
    # @param fleet_id ID for a fleet
    # @param squad_id The squad to delete
    # @param [Hash] opts the optional parameters
    # @option opts [String] :datasource The server name you would like data from (default to tranquility)
    # @option opts [String] :token Access token to use if unable to set a header
    # @return [nil]
    def delete_fleets_fleet_id_squads_squad_id(fleet_id, squad_id, opts = {})
      delete_fleets_fleet_id_squads_squad_id_with_http_info(fleet_id, squad_id, opts)
      return nil
    end

    # Delete fleet squad
    # Delete a fleet squad, only empty squads can be deleted  --- 
    # @param fleet_id ID for a fleet
    # @param squad_id The squad to delete
    # @param [Hash] opts the optional parameters
    # @option opts [String] :datasource The server name you would like data from
    # @option opts [String] :token Access token to use if unable to set a header
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_fleets_fleet_id_squads_squad_id_with_http_info(fleet_id, squad_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: FleetsApi.delete_fleets_fleet_id_squads_squad_id ..."
      end
      # verify the required parameter 'fleet_id' is set
      if @api_client.config.client_side_validation && fleet_id.nil?
        fail ArgumentError, "Missing the required parameter 'fleet_id' when calling FleetsApi.delete_fleets_fleet_id_squads_squad_id"
      end
      # verify the required parameter 'squad_id' is set
      if @api_client.config.client_side_validation && squad_id.nil?
        fail ArgumentError, "Missing the required parameter 'squad_id' when calling FleetsApi.delete_fleets_fleet_id_squads_squad_id"
      end
      if @api_client.config.client_side_validation && opts[:'datasource'] && !['tranquility', 'singularity'].include?(opts[:'datasource'])
        fail ArgumentError, 'invalid value for "datasource", must be one of tranquility, singularity'
      end
      # resource path
      local_var_path = "/v1/fleets/{fleet_id}/squads/{squad_id}/".sub('{' + 'fleet_id' + '}', fleet_id.to_s).sub('{' + 'squad_id' + '}', squad_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'datasource'] = opts[:'datasource'] if !opts[:'datasource'].nil?
      query_params[:'token'] = opts[:'token'] if !opts[:'token'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['evesso']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FleetsApi#delete_fleets_fleet_id_squads_squad_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete fleet wing
    # Delete a fleet wing, only empty wings can be deleted. The wing may contain squads, but the squads must be empty  --- 
    # @param fleet_id ID for a fleet
    # @param wing_id The wing to delete
    # @param [Hash] opts the optional parameters
    # @option opts [String] :datasource The server name you would like data from (default to tranquility)
    # @option opts [String] :token Access token to use if unable to set a header
    # @return [nil]
    def delete_fleets_fleet_id_wings_wing_id(fleet_id, wing_id, opts = {})
      delete_fleets_fleet_id_wings_wing_id_with_http_info(fleet_id, wing_id, opts)
      return nil
    end

    # Delete fleet wing
    # Delete a fleet wing, only empty wings can be deleted. The wing may contain squads, but the squads must be empty  --- 
    # @param fleet_id ID for a fleet
    # @param wing_id The wing to delete
    # @param [Hash] opts the optional parameters
    # @option opts [String] :datasource The server name you would like data from
    # @option opts [String] :token Access token to use if unable to set a header
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_fleets_fleet_id_wings_wing_id_with_http_info(fleet_id, wing_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: FleetsApi.delete_fleets_fleet_id_wings_wing_id ..."
      end
      # verify the required parameter 'fleet_id' is set
      if @api_client.config.client_side_validation && fleet_id.nil?
        fail ArgumentError, "Missing the required parameter 'fleet_id' when calling FleetsApi.delete_fleets_fleet_id_wings_wing_id"
      end
      # verify the required parameter 'wing_id' is set
      if @api_client.config.client_side_validation && wing_id.nil?
        fail ArgumentError, "Missing the required parameter 'wing_id' when calling FleetsApi.delete_fleets_fleet_id_wings_wing_id"
      end
      if @api_client.config.client_side_validation && opts[:'datasource'] && !['tranquility', 'singularity'].include?(opts[:'datasource'])
        fail ArgumentError, 'invalid value for "datasource", must be one of tranquility, singularity'
      end
      # resource path
      local_var_path = "/v1/fleets/{fleet_id}/wings/{wing_id}/".sub('{' + 'fleet_id' + '}', fleet_id.to_s).sub('{' + 'wing_id' + '}', wing_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'datasource'] = opts[:'datasource'] if !opts[:'datasource'].nil?
      query_params[:'token'] = opts[:'token'] if !opts[:'token'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['evesso']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FleetsApi#delete_fleets_fleet_id_wings_wing_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get character fleet info
    # Return the fleet ID the character is in, if any.  ---  This route is cached for up to 60 seconds
    # @param character_id An EVE character ID
    # @param [Hash] opts the optional parameters
    # @option opts [String] :datasource The server name you would like data from (default to tranquility)
    # @option opts [String] :if_none_match ETag from a previous request. A 304 will be returned if this matches the current ETag
    # @option opts [String] :token Access token to use if unable to set a header
    # @return [GetCharactersCharacterIdFleetOk]
    def get_characters_character_id_fleet(character_id, opts = {})
      data, _status_code, _headers = get_characters_character_id_fleet_with_http_info(character_id, opts)
      return data
    end

    # Get character fleet info
    # Return the fleet ID the character is in, if any.  ---  This route is cached for up to 60 seconds
    # @param character_id An EVE character ID
    # @param [Hash] opts the optional parameters
    # @option opts [String] :datasource The server name you would like data from
    # @option opts [String] :if_none_match ETag from a previous request. A 304 will be returned if this matches the current ETag
    # @option opts [String] :token Access token to use if unable to set a header
    # @return [Array<(GetCharactersCharacterIdFleetOk, Fixnum, Hash)>] GetCharactersCharacterIdFleetOk data, response status code and response headers
    def get_characters_character_id_fleet_with_http_info(character_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: FleetsApi.get_characters_character_id_fleet ..."
      end
      # verify the required parameter 'character_id' is set
      if @api_client.config.client_side_validation && character_id.nil?
        fail ArgumentError, "Missing the required parameter 'character_id' when calling FleetsApi.get_characters_character_id_fleet"
      end
      if @api_client.config.client_side_validation && character_id < 1
        fail ArgumentError, 'invalid value for "character_id" when calling FleetsApi.get_characters_character_id_fleet, must be greater than or equal to 1.'
      end

      if @api_client.config.client_side_validation && opts[:'datasource'] && !['tranquility', 'singularity'].include?(opts[:'datasource'])
        fail ArgumentError, 'invalid value for "datasource", must be one of tranquility, singularity'
      end
      # resource path
      local_var_path = "/v1/characters/{character_id}/fleet/".sub('{' + 'character_id' + '}', character_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'datasource'] = opts[:'datasource'] if !opts[:'datasource'].nil?
      query_params[:'token'] = opts[:'token'] if !opts[:'token'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])
      header_params[:'If-None-Match'] = opts[:'if_none_match'] if !opts[:'if_none_match'].nil?

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['evesso']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'GetCharactersCharacterIdFleetOk')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FleetsApi#get_characters_character_id_fleet\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get fleet information
    # Return details about a fleet  ---  This route is cached for up to 5 seconds
    # @param fleet_id ID for a fleet
    # @param [Hash] opts the optional parameters
    # @option opts [String] :datasource The server name you would like data from (default to tranquility)
    # @option opts [String] :if_none_match ETag from a previous request. A 304 will be returned if this matches the current ETag
    # @option opts [String] :token Access token to use if unable to set a header
    # @return [GetFleetsFleetIdOk]
    def get_fleets_fleet_id(fleet_id, opts = {})
      data, _status_code, _headers = get_fleets_fleet_id_with_http_info(fleet_id, opts)
      return data
    end

    # Get fleet information
    # Return details about a fleet  ---  This route is cached for up to 5 seconds
    # @param fleet_id ID for a fleet
    # @param [Hash] opts the optional parameters
    # @option opts [String] :datasource The server name you would like data from
    # @option opts [String] :if_none_match ETag from a previous request. A 304 will be returned if this matches the current ETag
    # @option opts [String] :token Access token to use if unable to set a header
    # @return [Array<(GetFleetsFleetIdOk, Fixnum, Hash)>] GetFleetsFleetIdOk data, response status code and response headers
    def get_fleets_fleet_id_with_http_info(fleet_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: FleetsApi.get_fleets_fleet_id ..."
      end
      # verify the required parameter 'fleet_id' is set
      if @api_client.config.client_side_validation && fleet_id.nil?
        fail ArgumentError, "Missing the required parameter 'fleet_id' when calling FleetsApi.get_fleets_fleet_id"
      end
      if @api_client.config.client_side_validation && opts[:'datasource'] && !['tranquility', 'singularity'].include?(opts[:'datasource'])
        fail ArgumentError, 'invalid value for "datasource", must be one of tranquility, singularity'
      end
      # resource path
      local_var_path = "/v1/fleets/{fleet_id}/".sub('{' + 'fleet_id' + '}', fleet_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'datasource'] = opts[:'datasource'] if !opts[:'datasource'].nil?
      query_params[:'token'] = opts[:'token'] if !opts[:'token'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])
      header_params[:'If-None-Match'] = opts[:'if_none_match'] if !opts[:'if_none_match'].nil?

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['evesso']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'GetFleetsFleetIdOk')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FleetsApi#get_fleets_fleet_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get fleet members
    # Return information about fleet members  ---  This route is cached for up to 5 seconds
    # @param fleet_id ID for a fleet
    # @param [Hash] opts the optional parameters
    # @option opts [String] :accept_language Language to use in the response (default to en-us)
    # @option opts [String] :datasource The server name you would like data from (default to tranquility)
    # @option opts [String] :if_none_match ETag from a previous request. A 304 will be returned if this matches the current ETag
    # @option opts [String] :language Language to use in the response, takes precedence over Accept-Language (default to en-us)
    # @option opts [String] :token Access token to use if unable to set a header
    # @return [Array<GetFleetsFleetIdMembers200Ok>]
    def get_fleets_fleet_id_members(fleet_id, opts = {})
      data, _status_code, _headers = get_fleets_fleet_id_members_with_http_info(fleet_id, opts)
      return data
    end

    # Get fleet members
    # Return information about fleet members  ---  This route is cached for up to 5 seconds
    # @param fleet_id ID for a fleet
    # @param [Hash] opts the optional parameters
    # @option opts [String] :accept_language Language to use in the response
    # @option opts [String] :datasource The server name you would like data from
    # @option opts [String] :if_none_match ETag from a previous request. A 304 will be returned if this matches the current ETag
    # @option opts [String] :language Language to use in the response, takes precedence over Accept-Language
    # @option opts [String] :token Access token to use if unable to set a header
    # @return [Array<(Array<GetFleetsFleetIdMembers200Ok>, Fixnum, Hash)>] Array<GetFleetsFleetIdMembers200Ok> data, response status code and response headers
    def get_fleets_fleet_id_members_with_http_info(fleet_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: FleetsApi.get_fleets_fleet_id_members ..."
      end
      # verify the required parameter 'fleet_id' is set
      if @api_client.config.client_side_validation && fleet_id.nil?
        fail ArgumentError, "Missing the required parameter 'fleet_id' when calling FleetsApi.get_fleets_fleet_id_members"
      end
      if @api_client.config.client_side_validation && opts[:'accept_language'] && !['de', 'en-us', 'fr', 'ja', 'ru', 'zh'].include?(opts[:'accept_language'])
        fail ArgumentError, 'invalid value for "accept_language", must be one of de, en-us, fr, ja, ru, zh'
      end
      if @api_client.config.client_side_validation && opts[:'datasource'] && !['tranquility', 'singularity'].include?(opts[:'datasource'])
        fail ArgumentError, 'invalid value for "datasource", must be one of tranquility, singularity'
      end
      if @api_client.config.client_side_validation && opts[:'language'] && !['de', 'en-us', 'fr', 'ja', 'ru', 'zh'].include?(opts[:'language'])
        fail ArgumentError, 'invalid value for "language", must be one of de, en-us, fr, ja, ru, zh'
      end
      # resource path
      local_var_path = "/v1/fleets/{fleet_id}/members/".sub('{' + 'fleet_id' + '}', fleet_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'datasource'] = opts[:'datasource'] if !opts[:'datasource'].nil?
      query_params[:'language'] = opts[:'language'] if !opts[:'language'].nil?
      query_params[:'token'] = opts[:'token'] if !opts[:'token'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])
      header_params[:'Accept-Language'] = opts[:'accept_language'] if !opts[:'accept_language'].nil?
      header_params[:'If-None-Match'] = opts[:'if_none_match'] if !opts[:'if_none_match'].nil?

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['evesso']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<GetFleetsFleetIdMembers200Ok>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FleetsApi#get_fleets_fleet_id_members\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get fleet wings
    # Return information about wings in a fleet  ---  This route is cached for up to 5 seconds
    # @param fleet_id ID for a fleet
    # @param [Hash] opts the optional parameters
    # @option opts [String] :accept_language Language to use in the response (default to en-us)
    # @option opts [String] :datasource The server name you would like data from (default to tranquility)
    # @option opts [String] :if_none_match ETag from a previous request. A 304 will be returned if this matches the current ETag
    # @option opts [String] :language Language to use in the response, takes precedence over Accept-Language (default to en-us)
    # @option opts [String] :token Access token to use if unable to set a header
    # @return [Array<GetFleetsFleetIdWings200Ok>]
    def get_fleets_fleet_id_wings(fleet_id, opts = {})
      data, _status_code, _headers = get_fleets_fleet_id_wings_with_http_info(fleet_id, opts)
      return data
    end

    # Get fleet wings
    # Return information about wings in a fleet  ---  This route is cached for up to 5 seconds
    # @param fleet_id ID for a fleet
    # @param [Hash] opts the optional parameters
    # @option opts [String] :accept_language Language to use in the response
    # @option opts [String] :datasource The server name you would like data from
    # @option opts [String] :if_none_match ETag from a previous request. A 304 will be returned if this matches the current ETag
    # @option opts [String] :language Language to use in the response, takes precedence over Accept-Language
    # @option opts [String] :token Access token to use if unable to set a header
    # @return [Array<(Array<GetFleetsFleetIdWings200Ok>, Fixnum, Hash)>] Array<GetFleetsFleetIdWings200Ok> data, response status code and response headers
    def get_fleets_fleet_id_wings_with_http_info(fleet_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: FleetsApi.get_fleets_fleet_id_wings ..."
      end
      # verify the required parameter 'fleet_id' is set
      if @api_client.config.client_side_validation && fleet_id.nil?
        fail ArgumentError, "Missing the required parameter 'fleet_id' when calling FleetsApi.get_fleets_fleet_id_wings"
      end
      if @api_client.config.client_side_validation && opts[:'accept_language'] && !['de', 'en-us', 'fr', 'ja', 'ru', 'zh'].include?(opts[:'accept_language'])
        fail ArgumentError, 'invalid value for "accept_language", must be one of de, en-us, fr, ja, ru, zh'
      end
      if @api_client.config.client_side_validation && opts[:'datasource'] && !['tranquility', 'singularity'].include?(opts[:'datasource'])
        fail ArgumentError, 'invalid value for "datasource", must be one of tranquility, singularity'
      end
      if @api_client.config.client_side_validation && opts[:'language'] && !['de', 'en-us', 'fr', 'ja', 'ru', 'zh'].include?(opts[:'language'])
        fail ArgumentError, 'invalid value for "language", must be one of de, en-us, fr, ja, ru, zh'
      end
      # resource path
      local_var_path = "/v1/fleets/{fleet_id}/wings/".sub('{' + 'fleet_id' + '}', fleet_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'datasource'] = opts[:'datasource'] if !opts[:'datasource'].nil?
      query_params[:'language'] = opts[:'language'] if !opts[:'language'].nil?
      query_params[:'token'] = opts[:'token'] if !opts[:'token'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])
      header_params[:'Accept-Language'] = opts[:'accept_language'] if !opts[:'accept_language'].nil?
      header_params[:'If-None-Match'] = opts[:'if_none_match'] if !opts[:'if_none_match'].nil?

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['evesso']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<GetFleetsFleetIdWings200Ok>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FleetsApi#get_fleets_fleet_id_wings\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Create fleet invitation
    # Invite a character into the fleet. If a character has a CSPA charge set it is not possible to invite them to the fleet using ESI  --- 
    # @param fleet_id ID for a fleet
    # @param invitation Details of the invitation
    # @param [Hash] opts the optional parameters
    # @option opts [String] :datasource The server name you would like data from (default to tranquility)
    # @option opts [String] :token Access token to use if unable to set a header
    # @return [nil]
    def post_fleets_fleet_id_members(fleet_id, invitation, opts = {})
      post_fleets_fleet_id_members_with_http_info(fleet_id, invitation, opts)
      return nil
    end

    # Create fleet invitation
    # Invite a character into the fleet. If a character has a CSPA charge set it is not possible to invite them to the fleet using ESI  --- 
    # @param fleet_id ID for a fleet
    # @param invitation Details of the invitation
    # @param [Hash] opts the optional parameters
    # @option opts [String] :datasource The server name you would like data from
    # @option opts [String] :token Access token to use if unable to set a header
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def post_fleets_fleet_id_members_with_http_info(fleet_id, invitation, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: FleetsApi.post_fleets_fleet_id_members ..."
      end
      # verify the required parameter 'fleet_id' is set
      if @api_client.config.client_side_validation && fleet_id.nil?
        fail ArgumentError, "Missing the required parameter 'fleet_id' when calling FleetsApi.post_fleets_fleet_id_members"
      end
      # verify the required parameter 'invitation' is set
      if @api_client.config.client_side_validation && invitation.nil?
        fail ArgumentError, "Missing the required parameter 'invitation' when calling FleetsApi.post_fleets_fleet_id_members"
      end
      if @api_client.config.client_side_validation && opts[:'datasource'] && !['tranquility', 'singularity'].include?(opts[:'datasource'])
        fail ArgumentError, 'invalid value for "datasource", must be one of tranquility, singularity'
      end
      # resource path
      local_var_path = "/v1/fleets/{fleet_id}/members/".sub('{' + 'fleet_id' + '}', fleet_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'datasource'] = opts[:'datasource'] if !opts[:'datasource'].nil?
      query_params[:'token'] = opts[:'token'] if !opts[:'token'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(invitation)
      auth_names = ['evesso']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FleetsApi#post_fleets_fleet_id_members\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Create fleet wing
    # Create a new wing in a fleet  --- 
    # @param fleet_id ID for a fleet
    # @param [Hash] opts the optional parameters
    # @option opts [String] :datasource The server name you would like data from (default to tranquility)
    # @option opts [String] :token Access token to use if unable to set a header
    # @return [PostFleetsFleetIdWingsCreated]
    def post_fleets_fleet_id_wings(fleet_id, opts = {})
      data, _status_code, _headers = post_fleets_fleet_id_wings_with_http_info(fleet_id, opts)
      return data
    end

    # Create fleet wing
    # Create a new wing in a fleet  --- 
    # @param fleet_id ID for a fleet
    # @param [Hash] opts the optional parameters
    # @option opts [String] :datasource The server name you would like data from
    # @option opts [String] :token Access token to use if unable to set a header
    # @return [Array<(PostFleetsFleetIdWingsCreated, Fixnum, Hash)>] PostFleetsFleetIdWingsCreated data, response status code and response headers
    def post_fleets_fleet_id_wings_with_http_info(fleet_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: FleetsApi.post_fleets_fleet_id_wings ..."
      end
      # verify the required parameter 'fleet_id' is set
      if @api_client.config.client_side_validation && fleet_id.nil?
        fail ArgumentError, "Missing the required parameter 'fleet_id' when calling FleetsApi.post_fleets_fleet_id_wings"
      end
      if @api_client.config.client_side_validation && opts[:'datasource'] && !['tranquility', 'singularity'].include?(opts[:'datasource'])
        fail ArgumentError, 'invalid value for "datasource", must be one of tranquility, singularity'
      end
      # resource path
      local_var_path = "/v1/fleets/{fleet_id}/wings/".sub('{' + 'fleet_id' + '}', fleet_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'datasource'] = opts[:'datasource'] if !opts[:'datasource'].nil?
      query_params[:'token'] = opts[:'token'] if !opts[:'token'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['evesso']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PostFleetsFleetIdWingsCreated')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FleetsApi#post_fleets_fleet_id_wings\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Create fleet squad
    # Create a new squad in a fleet  --- 
    # @param fleet_id ID for a fleet
    # @param wing_id The wing_id to create squad in
    # @param [Hash] opts the optional parameters
    # @option opts [String] :datasource The server name you would like data from (default to tranquility)
    # @option opts [String] :token Access token to use if unable to set a header
    # @return [PostFleetsFleetIdWingsWingIdSquadsCreated]
    def post_fleets_fleet_id_wings_wing_id_squads(fleet_id, wing_id, opts = {})
      data, _status_code, _headers = post_fleets_fleet_id_wings_wing_id_squads_with_http_info(fleet_id, wing_id, opts)
      return data
    end

    # Create fleet squad
    # Create a new squad in a fleet  --- 
    # @param fleet_id ID for a fleet
    # @param wing_id The wing_id to create squad in
    # @param [Hash] opts the optional parameters
    # @option opts [String] :datasource The server name you would like data from
    # @option opts [String] :token Access token to use if unable to set a header
    # @return [Array<(PostFleetsFleetIdWingsWingIdSquadsCreated, Fixnum, Hash)>] PostFleetsFleetIdWingsWingIdSquadsCreated data, response status code and response headers
    def post_fleets_fleet_id_wings_wing_id_squads_with_http_info(fleet_id, wing_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: FleetsApi.post_fleets_fleet_id_wings_wing_id_squads ..."
      end
      # verify the required parameter 'fleet_id' is set
      if @api_client.config.client_side_validation && fleet_id.nil?
        fail ArgumentError, "Missing the required parameter 'fleet_id' when calling FleetsApi.post_fleets_fleet_id_wings_wing_id_squads"
      end
      # verify the required parameter 'wing_id' is set
      if @api_client.config.client_side_validation && wing_id.nil?
        fail ArgumentError, "Missing the required parameter 'wing_id' when calling FleetsApi.post_fleets_fleet_id_wings_wing_id_squads"
      end
      if @api_client.config.client_side_validation && opts[:'datasource'] && !['tranquility', 'singularity'].include?(opts[:'datasource'])
        fail ArgumentError, 'invalid value for "datasource", must be one of tranquility, singularity'
      end
      # resource path
      local_var_path = "/v1/fleets/{fleet_id}/wings/{wing_id}/squads/".sub('{' + 'fleet_id' + '}', fleet_id.to_s).sub('{' + 'wing_id' + '}', wing_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'datasource'] = opts[:'datasource'] if !opts[:'datasource'].nil?
      query_params[:'token'] = opts[:'token'] if !opts[:'token'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['evesso']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PostFleetsFleetIdWingsWingIdSquadsCreated')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FleetsApi#post_fleets_fleet_id_wings_wing_id_squads\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update fleet
    # Update settings about a fleet  --- 
    # @param fleet_id ID for a fleet
    # @param new_settings What to update for this fleet
    # @param [Hash] opts the optional parameters
    # @option opts [String] :datasource The server name you would like data from (default to tranquility)
    # @option opts [String] :token Access token to use if unable to set a header
    # @return [nil]
    def put_fleets_fleet_id(fleet_id, new_settings, opts = {})
      put_fleets_fleet_id_with_http_info(fleet_id, new_settings, opts)
      return nil
    end

    # Update fleet
    # Update settings about a fleet  --- 
    # @param fleet_id ID for a fleet
    # @param new_settings What to update for this fleet
    # @param [Hash] opts the optional parameters
    # @option opts [String] :datasource The server name you would like data from
    # @option opts [String] :token Access token to use if unable to set a header
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def put_fleets_fleet_id_with_http_info(fleet_id, new_settings, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: FleetsApi.put_fleets_fleet_id ..."
      end
      # verify the required parameter 'fleet_id' is set
      if @api_client.config.client_side_validation && fleet_id.nil?
        fail ArgumentError, "Missing the required parameter 'fleet_id' when calling FleetsApi.put_fleets_fleet_id"
      end
      # verify the required parameter 'new_settings' is set
      if @api_client.config.client_side_validation && new_settings.nil?
        fail ArgumentError, "Missing the required parameter 'new_settings' when calling FleetsApi.put_fleets_fleet_id"
      end
      if @api_client.config.client_side_validation && opts[:'datasource'] && !['tranquility', 'singularity'].include?(opts[:'datasource'])
        fail ArgumentError, 'invalid value for "datasource", must be one of tranquility, singularity'
      end
      # resource path
      local_var_path = "/v1/fleets/{fleet_id}/".sub('{' + 'fleet_id' + '}', fleet_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'datasource'] = opts[:'datasource'] if !opts[:'datasource'].nil?
      query_params[:'token'] = opts[:'token'] if !opts[:'token'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(new_settings)
      auth_names = ['evesso']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FleetsApi#put_fleets_fleet_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Move fleet member
    # Move a fleet member around  --- 
    # @param fleet_id ID for a fleet
    # @param member_id The character ID of a member in this fleet
    # @param movement Details of the invitation
    # @param [Hash] opts the optional parameters
    # @option opts [String] :datasource The server name you would like data from (default to tranquility)
    # @option opts [String] :token Access token to use if unable to set a header
    # @return [nil]
    def put_fleets_fleet_id_members_member_id(fleet_id, member_id, movement, opts = {})
      put_fleets_fleet_id_members_member_id_with_http_info(fleet_id, member_id, movement, opts)
      return nil
    end

    # Move fleet member
    # Move a fleet member around  --- 
    # @param fleet_id ID for a fleet
    # @param member_id The character ID of a member in this fleet
    # @param movement Details of the invitation
    # @param [Hash] opts the optional parameters
    # @option opts [String] :datasource The server name you would like data from
    # @option opts [String] :token Access token to use if unable to set a header
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def put_fleets_fleet_id_members_member_id_with_http_info(fleet_id, member_id, movement, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: FleetsApi.put_fleets_fleet_id_members_member_id ..."
      end
      # verify the required parameter 'fleet_id' is set
      if @api_client.config.client_side_validation && fleet_id.nil?
        fail ArgumentError, "Missing the required parameter 'fleet_id' when calling FleetsApi.put_fleets_fleet_id_members_member_id"
      end
      # verify the required parameter 'member_id' is set
      if @api_client.config.client_side_validation && member_id.nil?
        fail ArgumentError, "Missing the required parameter 'member_id' when calling FleetsApi.put_fleets_fleet_id_members_member_id"
      end
      # verify the required parameter 'movement' is set
      if @api_client.config.client_side_validation && movement.nil?
        fail ArgumentError, "Missing the required parameter 'movement' when calling FleetsApi.put_fleets_fleet_id_members_member_id"
      end
      if @api_client.config.client_side_validation && opts[:'datasource'] && !['tranquility', 'singularity'].include?(opts[:'datasource'])
        fail ArgumentError, 'invalid value for "datasource", must be one of tranquility, singularity'
      end
      # resource path
      local_var_path = "/v1/fleets/{fleet_id}/members/{member_id}/".sub('{' + 'fleet_id' + '}', fleet_id.to_s).sub('{' + 'member_id' + '}', member_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'datasource'] = opts[:'datasource'] if !opts[:'datasource'].nil?
      query_params[:'token'] = opts[:'token'] if !opts[:'token'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(movement)
      auth_names = ['evesso']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FleetsApi#put_fleets_fleet_id_members_member_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Rename fleet squad
    # Rename a fleet squad  --- 
    # @param fleet_id ID for a fleet
    # @param naming New name of the squad
    # @param squad_id The squad to rename
    # @param [Hash] opts the optional parameters
    # @option opts [String] :datasource The server name you would like data from (default to tranquility)
    # @option opts [String] :token Access token to use if unable to set a header
    # @return [nil]
    def put_fleets_fleet_id_squads_squad_id(fleet_id, naming, squad_id, opts = {})
      put_fleets_fleet_id_squads_squad_id_with_http_info(fleet_id, naming, squad_id, opts)
      return nil
    end

    # Rename fleet squad
    # Rename a fleet squad  --- 
    # @param fleet_id ID for a fleet
    # @param naming New name of the squad
    # @param squad_id The squad to rename
    # @param [Hash] opts the optional parameters
    # @option opts [String] :datasource The server name you would like data from
    # @option opts [String] :token Access token to use if unable to set a header
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def put_fleets_fleet_id_squads_squad_id_with_http_info(fleet_id, naming, squad_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: FleetsApi.put_fleets_fleet_id_squads_squad_id ..."
      end
      # verify the required parameter 'fleet_id' is set
      if @api_client.config.client_side_validation && fleet_id.nil?
        fail ArgumentError, "Missing the required parameter 'fleet_id' when calling FleetsApi.put_fleets_fleet_id_squads_squad_id"
      end
      # verify the required parameter 'naming' is set
      if @api_client.config.client_side_validation && naming.nil?
        fail ArgumentError, "Missing the required parameter 'naming' when calling FleetsApi.put_fleets_fleet_id_squads_squad_id"
      end
      # verify the required parameter 'squad_id' is set
      if @api_client.config.client_side_validation && squad_id.nil?
        fail ArgumentError, "Missing the required parameter 'squad_id' when calling FleetsApi.put_fleets_fleet_id_squads_squad_id"
      end
      if @api_client.config.client_side_validation && opts[:'datasource'] && !['tranquility', 'singularity'].include?(opts[:'datasource'])
        fail ArgumentError, 'invalid value for "datasource", must be one of tranquility, singularity'
      end
      # resource path
      local_var_path = "/v1/fleets/{fleet_id}/squads/{squad_id}/".sub('{' + 'fleet_id' + '}', fleet_id.to_s).sub('{' + 'squad_id' + '}', squad_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'datasource'] = opts[:'datasource'] if !opts[:'datasource'].nil?
      query_params[:'token'] = opts[:'token'] if !opts[:'token'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(naming)
      auth_names = ['evesso']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FleetsApi#put_fleets_fleet_id_squads_squad_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Rename fleet wing
    # Rename a fleet wing  --- 
    # @param fleet_id ID for a fleet
    # @param naming New name of the wing
    # @param wing_id The wing to rename
    # @param [Hash] opts the optional parameters
    # @option opts [String] :datasource The server name you would like data from (default to tranquility)
    # @option opts [String] :token Access token to use if unable to set a header
    # @return [nil]
    def put_fleets_fleet_id_wings_wing_id(fleet_id, naming, wing_id, opts = {})
      put_fleets_fleet_id_wings_wing_id_with_http_info(fleet_id, naming, wing_id, opts)
      return nil
    end

    # Rename fleet wing
    # Rename a fleet wing  --- 
    # @param fleet_id ID for a fleet
    # @param naming New name of the wing
    # @param wing_id The wing to rename
    # @param [Hash] opts the optional parameters
    # @option opts [String] :datasource The server name you would like data from
    # @option opts [String] :token Access token to use if unable to set a header
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def put_fleets_fleet_id_wings_wing_id_with_http_info(fleet_id, naming, wing_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: FleetsApi.put_fleets_fleet_id_wings_wing_id ..."
      end
      # verify the required parameter 'fleet_id' is set
      if @api_client.config.client_side_validation && fleet_id.nil?
        fail ArgumentError, "Missing the required parameter 'fleet_id' when calling FleetsApi.put_fleets_fleet_id_wings_wing_id"
      end
      # verify the required parameter 'naming' is set
      if @api_client.config.client_side_validation && naming.nil?
        fail ArgumentError, "Missing the required parameter 'naming' when calling FleetsApi.put_fleets_fleet_id_wings_wing_id"
      end
      # verify the required parameter 'wing_id' is set
      if @api_client.config.client_side_validation && wing_id.nil?
        fail ArgumentError, "Missing the required parameter 'wing_id' when calling FleetsApi.put_fleets_fleet_id_wings_wing_id"
      end
      if @api_client.config.client_side_validation && opts[:'datasource'] && !['tranquility', 'singularity'].include?(opts[:'datasource'])
        fail ArgumentError, 'invalid value for "datasource", must be one of tranquility, singularity'
      end
      # resource path
      local_var_path = "/v1/fleets/{fleet_id}/wings/{wing_id}/".sub('{' + 'fleet_id' + '}', fleet_id.to_s).sub('{' + 'wing_id' + '}', wing_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'datasource'] = opts[:'datasource'] if !opts[:'datasource'].nil?
      query_params[:'token'] = opts[:'token'] if !opts[:'token'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(naming)
      auth_names = ['evesso']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FleetsApi#put_fleets_fleet_id_wings_wing_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
