=begin
#EVE Swagger Interface

#An OpenAPI for EVE Online

OpenAPI spec version: 0.8.6

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.3.1

=end

require 'date'

module ESI
  # 200 ok object
  class GetCharactersCharacterIdPlanets200Ok
    # last_update string
    attr_accessor :last_update

    # num_pins integer
    attr_accessor :num_pins

    # owner_id integer
    attr_accessor :owner_id

    # planet_id integer
    attr_accessor :planet_id

    # planet_type string
    attr_accessor :planet_type

    # solar_system_id integer
    attr_accessor :solar_system_id

    # upgrade_level integer
    attr_accessor :upgrade_level

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'last_update' => :'last_update',
        :'num_pins' => :'num_pins',
        :'owner_id' => :'owner_id',
        :'planet_id' => :'planet_id',
        :'planet_type' => :'planet_type',
        :'solar_system_id' => :'solar_system_id',
        :'upgrade_level' => :'upgrade_level'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'last_update' => :'DateTime',
        :'num_pins' => :'Integer',
        :'owner_id' => :'Integer',
        :'planet_id' => :'Integer',
        :'planet_type' => :'String',
        :'solar_system_id' => :'Integer',
        :'upgrade_level' => :'Integer'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      if attributes.has_key?(:'last_update')
        self.last_update = attributes[:'last_update']
      end

      if attributes.has_key?(:'num_pins')
        self.num_pins = attributes[:'num_pins']
      end

      if attributes.has_key?(:'owner_id')
        self.owner_id = attributes[:'owner_id']
      end

      if attributes.has_key?(:'planet_id')
        self.planet_id = attributes[:'planet_id']
      end

      if attributes.has_key?(:'planet_type')
        self.planet_type = attributes[:'planet_type']
      end

      if attributes.has_key?(:'solar_system_id')
        self.solar_system_id = attributes[:'solar_system_id']
      end

      if attributes.has_key?(:'upgrade_level')
        self.upgrade_level = attributes[:'upgrade_level']
      end

    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @last_update.nil?
        invalid_properties.push("invalid value for 'last_update', last_update cannot be nil.")
      end

      if @num_pins.nil?
        invalid_properties.push("invalid value for 'num_pins', num_pins cannot be nil.")
      end

      if @num_pins < 1
        invalid_properties.push("invalid value for 'num_pins', must be greater than or equal to 1.")
      end

      if @owner_id.nil?
        invalid_properties.push("invalid value for 'owner_id', owner_id cannot be nil.")
      end

      if @planet_id.nil?
        invalid_properties.push("invalid value for 'planet_id', planet_id cannot be nil.")
      end

      if @planet_type.nil?
        invalid_properties.push("invalid value for 'planet_type', planet_type cannot be nil.")
      end

      if @solar_system_id.nil?
        invalid_properties.push("invalid value for 'solar_system_id', solar_system_id cannot be nil.")
      end

      if @upgrade_level.nil?
        invalid_properties.push("invalid value for 'upgrade_level', upgrade_level cannot be nil.")
      end

      if @upgrade_level > 5
        invalid_properties.push("invalid value for 'upgrade_level', must be smaller than or equal to 5.")
      end

      if @upgrade_level < 0
        invalid_properties.push("invalid value for 'upgrade_level', must be greater than or equal to 0.")
      end

      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @last_update.nil?
      return false if @num_pins.nil?
      return false if @num_pins < 1
      return false if @owner_id.nil?
      return false if @planet_id.nil?
      return false if @planet_type.nil?
      planet_type_validator = EnumAttributeValidator.new('String', ["temperate", "barren", "oceanic", "ice", "gas", "lava", "storm", "plasma"])
      return false unless planet_type_validator.valid?(@planet_type)
      return false if @solar_system_id.nil?
      return false if @upgrade_level.nil?
      return false if @upgrade_level > 5
      return false if @upgrade_level < 0
      return true
    end

    # Custom attribute writer method with validation
    # @param [Object] num_pins Value to be assigned
    def num_pins=(num_pins)
      if num_pins.nil?
        fail ArgumentError, "num_pins cannot be nil"
      end

      if num_pins < 1
        fail ArgumentError, "invalid value for 'num_pins', must be greater than or equal to 1."
      end

      @num_pins = num_pins
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] planet_type Object to be assigned
    def planet_type=(planet_type)
      validator = EnumAttributeValidator.new('String', ["temperate", "barren", "oceanic", "ice", "gas", "lava", "storm", "plasma"])
      unless validator.valid?(planet_type)
        fail ArgumentError, "invalid value for 'planet_type', must be one of #{validator.allowable_values}."
      end
      @planet_type = planet_type
    end

    # Custom attribute writer method with validation
    # @param [Object] upgrade_level Value to be assigned
    def upgrade_level=(upgrade_level)
      if upgrade_level.nil?
        fail ArgumentError, "upgrade_level cannot be nil"
      end

      if upgrade_level > 5
        fail ArgumentError, "invalid value for 'upgrade_level', must be smaller than or equal to 5."
      end

      if upgrade_level < 0
        fail ArgumentError, "invalid value for 'upgrade_level', must be greater than or equal to 0."
      end

      @upgrade_level = upgrade_level
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          last_update == o.last_update &&
          num_pins == o.num_pins &&
          owner_id == o.owner_id &&
          planet_id == o.planet_id &&
          planet_type == o.planet_type &&
          solar_system_id == o.solar_system_id &&
          upgrade_level == o.upgrade_level
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [last_update, num_pins, owner_id, planet_id, planet_type, solar_system_id, upgrade_level].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = ESI.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
