=begin
#EVE Swagger Interface

#An OpenAPI for EVE Online

OpenAPI spec version: 0.8.6

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.3.1

=end

require 'date'

module ESI
  # 200 ok object
  class GetCharactersCharacterIdSearchOk
    # agent array
    attr_accessor :agent

    # alliance array
    attr_accessor :alliance

    # character array
    attr_accessor :character

    # constellation array
    attr_accessor :constellation

    # corporation array
    attr_accessor :corporation

    # faction array
    attr_accessor :faction

    # inventory_type array
    attr_accessor :inventory_type

    # region array
    attr_accessor :region

    # solar_system array
    attr_accessor :solar_system

    # station array
    attr_accessor :station

    # structure array
    attr_accessor :structure


    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'agent' => :'agent',
        :'alliance' => :'alliance',
        :'character' => :'character',
        :'constellation' => :'constellation',
        :'corporation' => :'corporation',
        :'faction' => :'faction',
        :'inventory_type' => :'inventory_type',
        :'region' => :'region',
        :'solar_system' => :'solar_system',
        :'station' => :'station',
        :'structure' => :'structure'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'agent' => :'Array<Integer>',
        :'alliance' => :'Array<Integer>',
        :'character' => :'Array<Integer>',
        :'constellation' => :'Array<Integer>',
        :'corporation' => :'Array<Integer>',
        :'faction' => :'Array<Integer>',
        :'inventory_type' => :'Array<Integer>',
        :'region' => :'Array<Integer>',
        :'solar_system' => :'Array<Integer>',
        :'station' => :'Array<Integer>',
        :'structure' => :'Array<Integer>'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      if attributes.has_key?(:'agent')
        if (value = attributes[:'agent']).is_a?(Array)
          self.agent = value
        end
      end

      if attributes.has_key?(:'alliance')
        if (value = attributes[:'alliance']).is_a?(Array)
          self.alliance = value
        end
      end

      if attributes.has_key?(:'character')
        if (value = attributes[:'character']).is_a?(Array)
          self.character = value
        end
      end

      if attributes.has_key?(:'constellation')
        if (value = attributes[:'constellation']).is_a?(Array)
          self.constellation = value
        end
      end

      if attributes.has_key?(:'corporation')
        if (value = attributes[:'corporation']).is_a?(Array)
          self.corporation = value
        end
      end

      if attributes.has_key?(:'faction')
        if (value = attributes[:'faction']).is_a?(Array)
          self.faction = value
        end
      end

      if attributes.has_key?(:'inventory_type')
        if (value = attributes[:'inventory_type']).is_a?(Array)
          self.inventory_type = value
        end
      end

      if attributes.has_key?(:'region')
        if (value = attributes[:'region']).is_a?(Array)
          self.region = value
        end
      end

      if attributes.has_key?(:'solar_system')
        if (value = attributes[:'solar_system']).is_a?(Array)
          self.solar_system = value
        end
      end

      if attributes.has_key?(:'station')
        if (value = attributes[:'station']).is_a?(Array)
          self.station = value
        end
      end

      if attributes.has_key?(:'structure')
        if (value = attributes[:'structure']).is_a?(Array)
          self.structure = value
        end
      end

    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          agent == o.agent &&
          alliance == o.alliance &&
          character == o.character &&
          constellation == o.constellation &&
          corporation == o.corporation &&
          faction == o.faction &&
          inventory_type == o.inventory_type &&
          region == o.region &&
          solar_system == o.solar_system &&
          station == o.station &&
          structure == o.structure
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [agent, alliance, character, constellation, corporation, faction, inventory_type, region, solar_system, station, structure].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = ESI.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
