=begin
#EVE Swagger Interface

#An OpenAPI for EVE Online

OpenAPI spec version: 0.8.6

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.3.1

=end

require 'date'

module ESI
  # 200 ok object
  class GetFwSystems200Ok
    # contested string
    attr_accessor :contested

    # occupier_faction_id integer
    attr_accessor :occupier_faction_id

    # owner_faction_id integer
    attr_accessor :owner_faction_id

    # solar_system_id integer
    attr_accessor :solar_system_id

    # victory_points integer
    attr_accessor :victory_points

    # victory_points_threshold integer
    attr_accessor :victory_points_threshold

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'contested' => :'contested',
        :'occupier_faction_id' => :'occupier_faction_id',
        :'owner_faction_id' => :'owner_faction_id',
        :'solar_system_id' => :'solar_system_id',
        :'victory_points' => :'victory_points',
        :'victory_points_threshold' => :'victory_points_threshold'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'contested' => :'String',
        :'occupier_faction_id' => :'Integer',
        :'owner_faction_id' => :'Integer',
        :'solar_system_id' => :'Integer',
        :'victory_points' => :'Integer',
        :'victory_points_threshold' => :'Integer'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      if attributes.has_key?(:'contested')
        self.contested = attributes[:'contested']
      end

      if attributes.has_key?(:'occupier_faction_id')
        self.occupier_faction_id = attributes[:'occupier_faction_id']
      end

      if attributes.has_key?(:'owner_faction_id')
        self.owner_faction_id = attributes[:'owner_faction_id']
      end

      if attributes.has_key?(:'solar_system_id')
        self.solar_system_id = attributes[:'solar_system_id']
      end

      if attributes.has_key?(:'victory_points')
        self.victory_points = attributes[:'victory_points']
      end

      if attributes.has_key?(:'victory_points_threshold')
        self.victory_points_threshold = attributes[:'victory_points_threshold']
      end

    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @contested.nil?
        invalid_properties.push("invalid value for 'contested', contested cannot be nil.")
      end

      if @occupier_faction_id.nil?
        invalid_properties.push("invalid value for 'occupier_faction_id', occupier_faction_id cannot be nil.")
      end

      if @owner_faction_id.nil?
        invalid_properties.push("invalid value for 'owner_faction_id', owner_faction_id cannot be nil.")
      end

      if @solar_system_id.nil?
        invalid_properties.push("invalid value for 'solar_system_id', solar_system_id cannot be nil.")
      end

      if @victory_points.nil?
        invalid_properties.push("invalid value for 'victory_points', victory_points cannot be nil.")
      end

      if @victory_points_threshold.nil?
        invalid_properties.push("invalid value for 'victory_points_threshold', victory_points_threshold cannot be nil.")
      end

      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @contested.nil?
      contested_validator = EnumAttributeValidator.new('String', ["captured", "contested", "uncontested", "vulnerable"])
      return false unless contested_validator.valid?(@contested)
      return false if @occupier_faction_id.nil?
      return false if @owner_faction_id.nil?
      return false if @solar_system_id.nil?
      return false if @victory_points.nil?
      return false if @victory_points_threshold.nil?
      return true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] contested Object to be assigned
    def contested=(contested)
      validator = EnumAttributeValidator.new('String', ["captured", "contested", "uncontested", "vulnerable"])
      unless validator.valid?(contested)
        fail ArgumentError, "invalid value for 'contested', must be one of #{validator.allowable_values}."
      end
      @contested = contested
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          contested == o.contested &&
          occupier_faction_id == o.occupier_faction_id &&
          owner_faction_id == o.owner_faction_id &&
          solar_system_id == o.solar_system_id &&
          victory_points == o.victory_points &&
          victory_points_threshold == o.victory_points_threshold
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [contested, occupier_faction_id, owner_faction_id, solar_system_id, victory_points, victory_points_threshold].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = ESI.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
