=begin
#EVE Swagger Interface

#An OpenAPI for EVE Online

OpenAPI spec version: 0.8.6

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.3.1

=end

require 'date'

module ESI
  # new_mail object
  class PostUiOpenwindowNewmailNewMail
    # body string
    attr_accessor :body

    # recipients array
    attr_accessor :recipients

    # subject string
    attr_accessor :subject

    # to_corp_or_alliance_id integer
    attr_accessor :to_corp_or_alliance_id

    # Corporations, alliances and mailing lists are all types of mailing groups. You may only send to one mailing group, at a time, so you may fill out either this field or the to_corp_or_alliance_ids field
    attr_accessor :to_mailing_list_id


    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'body' => :'body',
        :'recipients' => :'recipients',
        :'subject' => :'subject',
        :'to_corp_or_alliance_id' => :'to_corp_or_alliance_id',
        :'to_mailing_list_id' => :'to_mailing_list_id'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'body' => :'String',
        :'recipients' => :'Array<Integer>',
        :'subject' => :'String',
        :'to_corp_or_alliance_id' => :'Integer',
        :'to_mailing_list_id' => :'Integer'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      if attributes.has_key?(:'body')
        self.body = attributes[:'body']
      end

      if attributes.has_key?(:'recipients')
        if (value = attributes[:'recipients']).is_a?(Array)
          self.recipients = value
        end
      end

      if attributes.has_key?(:'subject')
        self.subject = attributes[:'subject']
      end

      if attributes.has_key?(:'to_corp_or_alliance_id')
        self.to_corp_or_alliance_id = attributes[:'to_corp_or_alliance_id']
      end

      if attributes.has_key?(:'to_mailing_list_id')
        self.to_mailing_list_id = attributes[:'to_mailing_list_id']
      end

    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @body.nil?
        invalid_properties.push("invalid value for 'body', body cannot be nil.")
      end

      if @body.to_s.length > 10000
        invalid_properties.push("invalid value for 'body', the character length must be smaller than or equal to 10000.")
      end

      if @recipients.nil?
        invalid_properties.push("invalid value for 'recipients', recipients cannot be nil.")
      end

      if @subject.nil?
        invalid_properties.push("invalid value for 'subject', subject cannot be nil.")
      end

      if @subject.to_s.length > 1000
        invalid_properties.push("invalid value for 'subject', the character length must be smaller than or equal to 1000.")
      end

      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @body.nil?
      return false if @body.to_s.length > 10000
      return false if @recipients.nil?
      return false if @subject.nil?
      return false if @subject.to_s.length > 1000
      return true
    end

    # Custom attribute writer method with validation
    # @param [Object] body Value to be assigned
    def body=(body)
      if body.nil?
        fail ArgumentError, "body cannot be nil"
      end

      if body.to_s.length > 10000
        fail ArgumentError, "invalid value for 'body', the character length must be smaller than or equal to 10000."
      end

      @body = body
    end

    # Custom attribute writer method with validation
    # @param [Object] subject Value to be assigned
    def subject=(subject)
      if subject.nil?
        fail ArgumentError, "subject cannot be nil"
      end

      if subject.to_s.length > 1000
        fail ArgumentError, "invalid value for 'subject', the character length must be smaller than or equal to 1000."
      end

      @subject = subject
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          body == o.body &&
          recipients == o.recipients &&
          subject == o.subject &&
          to_corp_or_alliance_id == o.to_corp_or_alliance_id &&
          to_mailing_list_id == o.to_mailing_list_id
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [body, recipients, subject, to_corp_or_alliance_id, to_mailing_list_id].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = ESI.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
